'''
20110209 EC
AProcess
combined loopRun pyRenderUtil for visualising/output scripted animations

'''

import math, random
from maya.OpenMaya import MVector
from maya.OpenMaya import MPoint
import maya.cmds as cmds
import maya.mel as mel
import os
import time
import shutil
import testrun,pyMGL
import threading

from maya.OpenMaya import MImage


count = 0
renderBln = 0

def about():
	aboutMsg = """
AProcess build20110209
2010-2011 E.PYC 

for visualising/output scripted animations

more info at http://eric.pycheung.com
	"""
	cmds.confirmDialog( title='About', message=aboutMsg, button='ok')


########### UI
def getTextValue(fieldName):
	#print cmds.textField(fieldName, q=1,tx=1 )
	return cmds.textField(fieldName, q=1,tx=1 )
	
def setTextValue(fieldName,value):
	cmds.textField(fieldName, e=1,tx=value )
	
def setExpression(function):
	#evalDeferred `python("timeWrapper()")`; 

	expression = cmds.expression(s="evalDeferred `python( \""+function+"\" )`;")
	#expression = cmds.expression(s="python( \""+function+"\" );")
	
def runCommand(function,times, ss):
	# evalDeferred `python("timeWrapper()")`; 
	try:
		#print ss
		for i in range(0, int(times)):
			
			if int(ss) != 0:
				exe(function)
			else:
				cmds.evalDeferred(function)
			
			# incrementCounter()
	except:
		print "not run: check function/times"
	#expression = cmds.expression(s="python( \""+function+"\" );")

	
# import pyMGL
class soundPlay(threading.Thread):
	def __init__(self, function, times):
		threading.Thread.__init__(self)
		self.function = function
		self.times = times


			# cmds.evalDeferred(function)
			# print "test", i
		self.time_quit = threading.Event()
		self.time_quit.clear()
		print "thread end"
		# self.stop()
		
	def stop(self):
		self.time_quit.set()

	def run(self):
		for i in range(int(self.times)):
			# exe(function)
			exec(self.function)
			print "test", i 
			# cmds.refresh()
			
			# pyMGL.buildGL()
		self.stop()
			
	
def runCommandwithThread(function,times, ss):
	try:
		#print ss
		
		thread = soundPlay(function,times)
		thread.start()
		
			# incrementCounter()
	except:
		print "not run: check function/times"

	
cmds.setAttr("defaultRenderGlobals.imageFormat",8) #JPG

def playBlast(frame,substeps,savePath):

	cmds.displayRGBColor("background",1,1,1)
	cmds.displayRGBColor("backgroundTop",1,1,1)
	cmds.displayRGBColor("backgroundBottom",1,1,1)
	# cmds.playblast(cf=savePath+str(frame)+str(substeps)+".jpg",wh=[4000,3000],fmt="image",viewer=0,orn=0,p=100,fr=1,offScreen=1) #fr=1
	# cmds.playblast(f=savePath+str(frame)+str(substeps)+".jpg",wh=[4000,3000],fmt="image",viewer=0,fp=4,orn=0,p=100,ifz=0,fo=1,offScreen=1) #fr=1
	# print "saved"
	outpath = cmds.playblast(frame=frame,fmt="image",viewer=0,wh=[4000,3000],fp=4,orn=0,p=100,ifz=0,fo=1,offScreen=1,f=savePath+str(frame)+str(substeps)+".jpg")
	cmds.displayRGBColor(rs=1)	
	
	
def playBlast2(savePath,type="png"):
	# cmds.displayRGBColor("background",1,1,1)
	# cmds.displayRGBColor("backgroundTop",1,1,1)
	# cmds.displayRGBColor("backgroundBottom",1,1,1)
	global count
	count+=1
	counterF = "%04d" % (count)
	
	outpath = cmds.playblast(frame=1,fmt="image",viewer=0,wh=[4000,3000],fp=4,orn=0,p=100,ifz=0,fo=1,offScreen=1,f=savePath+str(counterF))
	# print path
	path1 = os.path.splitext(outpath) #c:\playblast\screenshot.####.iff
	realpath = os.path.splitext(path1[0])[0]+".0000.iff"
	# print realpath
	#cmds.displayRGBColor(rs=1)
	
	parsepath = os.path.splitext(realpath)
	mayaImage = MImage()
	mayaImage.readFromFile(realpath) #"C:\\playblast\\screenshot.0000.iff"
	mayaImage.writeToFile( "%s.%s" % (parsepath[0],type),type)
	os.remove(realpath)
	
def exe(function):
	#print function
	# statement = "\""+function+"\""
	# print statement
	# exec(statement)
	# exec("\""+function+"\"")
	#exec("testrun.draw()")
	#exec("timeWrapper()")
	# mel.eval("python(\""+function+"\");")
	exec(function)
	
################################# Code from 20110205 EC renderUtil

def screenshot(function,startNum,endNum,savePath):
	setTextValue("renderBln",0)
	renderBln = 0

	startNum = int(startNum)
	endNum = int(endNum)
	
	if endNum > startNum:
		counter = int(startNum)

		for i in range(0,int(endNum)-int(startNum)):
		
			exec(function)
			# cmds.evalDeferred(function)

			
			try:
				pyMGL.showText()
				pyMGL.buildGL()
				pyMGL.updateNode()
			except:
				pass
				
			counterF = "%04d" % (counter)
			playBlast(counterF,"",savePath)
			counter += 1
			
		# incrementCounter()

def renderRange(function,startNum,endNum,savePath):
	setTextValue("renderBln",0)
	renderBln = 0
	
	startNum = int(startNum)
	endNum = int(endNum)
	
	if endNum > startNum:
		#METHOD 1 - run the block of code when you init the render loop
		
		# exec(str(function))
		# print function
		
		#settings
		counter = int(startNum)
		# cam = "persp"
		# camShape = cmds.listRelatives(cam,shapes=1)
		# print camShape
		# savePath = r"c:\renders\test"

		for i in range(0,int(endNum)-int(startNum)):
			
			#Run demo function
			exe(function)
			
			#if frame is important
			#cmds.currentTime( counter, edit=True )
			
			#tmpImage = cmds.render(cam, batch=1) #software render
			# tmpImage = cmds.Mayatomr(camera=camShape[0],pv=True) #mentalray non-batch
			# tmpImage = cmds.Mayatomr(pv=True) #mentalray non-batch
			
			# parsePath = os.path.splitext(tmpImage)
			# counterF = "%04d" % (counter)
			# shutil.move(tmpImage,savePath+counterF+parsePath[1]) #move file
			render(counter,"",savePath)
			counter += 1
			
			# print savePath+counterF+parsePath[1]
			# incrementCounter()
			
	else:
		print "endNum < startNum"

def render(counter,substeps,savePath):
	tmpImage = cmds.Mayatomr(pv=True) #mentalray non-batch
	parseEXT = os.path.splitext(tmpImage)
	counterF = "%04d" % (counter)
	shutil.move(tmpImage,savePath+counterF+substeps+parseEXT[1]) #move file
	# print savePath+counterF+substeps+parseEXT[1]
	return savePath+counterF+substeps+parseEXT[1]
	
def scriptRender(substeps):
	global count
	render(count,substeps,getSavePath())

def scriptShots(substeps):
	global count
	savePath = getSavePath()
	counterF = "%04d" % (count)
	playBlast(counterF,substeps,savePath)
	
def updateCount():
	# print getTextValue("counter")
	global count
	setTextValue("counter",count)
	
def toggleRenderBln():
	# print getTextValue("counter")
	global renderBln
	current = int(getTextValue("renderBln"))
	if current:
		setTextValue("renderBln",0)
		renderBln = 0
	else:
		setTextValue("renderBln",1)
		renderBln = 1
		
def incrementCounter():
	global count
	count += 1
	updateCount()

def getSavePath():
	return getTextValue("savePath")+"/"+getTextValue("savePrefix")
	
#######################################################################################
def ui():

	if cmds.dockControl("AProcessUIdock",exists=1):
		cmds.deleteUI("AProcessUIdock")
	if cmds.window("AProcessUI",exists=1):
		cmds.deleteUI("AProcessUI")

	window_AP = cmds.window("AProcessUI", title="AProcess.ui() v1", iconName='AProcess', widthHeight=(300, 600) )
	
	cmds.rowColumnLayout( numberOfColumns=1 ) #, columnWidth=[(1, 200)] )
	allowedAreas = ['right', 'left']
	cmds.dockControl("AProcessUIdock",l="AProcess", w=300, area='right', content=window_AP, allowedArea=allowedAreas )
	
	#cmds.rowColumnLayout( numberOfColumns=3, columnWidth=[(1, 130),(2, 50), (3, 120)] )
	

	
	cmds.frameLayout( label='Render-in-script variables' ,cll=1)
	cmds.rowColumnLayout( numberOfColumns=2, columnWidth=[(1, 100)] )
	cmds.text( label='RenderBln', align='left')
	cmds.textField( "renderBln", tx='0', editable=0)
	
	cmds.separator( style='none' )
	cmds.button( label='Toggle renderBln', command=('AProcess.toggleRenderBln()') )
	
	cmds.text( label='Run Count', align='left')
	cmds.textField( "counter", tx='0') #, editable=0)
	
	cmds.separator( style='none' )
	cmds.button( label='Set Counter', command=('AProcess.count = int(AProcess.getTextValue("counter"));AProcess.updateCount()') )
	
	cmds.separator( style='none' )
	cmds.button( label='Reset Counter', command=('AProcess.count = 0;AProcess.updateCount()') )

	cmds.setParent( '..' )
	cmds.setParent( '..' )
	
	
	
	cmds.frameLayout( label='Function' ,cll=1)
	cmds.rowColumnLayout( numberOfColumns=2, columnWidth=[(1, 100)] )
	cmds.text( label='PYTHON FUNCTION', align='left')
	# cmds.textField( "drawProcess", tx='testrun.timeWrapper()')
	cmds.textField( "drawProcess", tx='testrun.draw()')
	cmds.setParent( '..' )
	cmds.setParent( '..' )
	
	
	cmds.frameLayout( label='Run' ,cll=1)
	cmds.rowColumnLayout( numberOfColumns=2, columnWidth=[(1, 100)] )
	#############################
	cmds.text( label='EXPRESSION', align='left')
	cmds.separator( style='none' )
	
	cmds.separator( style='none' )
	cmds.button( label='Attach Expression', command=('AProcess.setExpression(AProcess.getTextValue("drawProcess"))') )

	cmds.separator( style='none' )
	cmds.button( label='Expression Editor', command=('cmds.ExpressionEditor()') )
	
	#############################
	cmds.text( label='RUN', align='left')
	cmds.separator( style='none' )
	
	cmds.separator( style='none' )
	cmds.button( label='Run Once (Exec)', command=('AProcess.exe(AProcess.getTextValue("drawProcess"))') )
	
	cmds.separator( style='none' )
	cmds.button( label='Run Once (Deferred)', command=('AProcess.runCommand(AProcess.getTextValue("drawProcess"),1,0)') )
	
	# cmds.textField( "myFloatSStxt", tx='0')
	# cmds.text( label='saveScreen', align='left')
	cmds.text( label='number of times', align='left')
	cmds.textField( "myFloatTimetxt", tx='20')
	
	# cmds.textField( "exeToggle", tx='1')
	cmds.separator( style='none' )
	cmds.button( label='Run N Times (Exec)', command=('AProcess.runCommand(AProcess.getTextValue("drawProcess"),AProcess.getTextValue("myFloatTimetxt"),1)') )

	cmds.separator( style='none' )
	cmds.button( label='Run N Times (Deferred)', command=('AProcess.runCommand(AProcess.getTextValue("drawProcess"),AProcess.getTextValue("myFloatTimetxt"),0)') )
	
	
	cmds.separator( style='none' )
	cmds.button( label='Run in bg', command=('AProcess.runCommandwithThread(AProcess.getTextValue("drawProcess"),AProcess.getTextValue("myFloatTimetxt"),0)') )

	#############################
	cmds.setParent( '..' )
	cmds.setParent( '..' )
	
	
	cmds.frameLayout( label='Render / Output' ,cll=1)
	cmds.rowColumnLayout( numberOfColumns=2, columnWidth=[(1, 100)] )
	# cmds.text( label='RENDER', align='left')
	# cmds.separator( style='none' )
	
	cmds.text( label='path to save', align='left')
	cmds.textField( "savePath", tx=r'c:\renders' )
	
	cmds.text( label='filename prefix', align='left')
	cmds.textField( "savePrefix", tx=r'tmpFile')
	
	cmds.text( label='start number', align='left')
	cmds.textField( "startNumer", tx='0')
	
	cmds.text( label='end number', align='left')
	cmds.textField( "endNumer", tx='5')
	
	cmds.separator( style='none' )
	cmds.button( label='Render Range (MentalRay)', command=('AProcess.renderRange(AProcess.getTextValue("drawProcess"),AProcess.getTextValue("startNumer"),AProcess.getTextValue("endNumer"),AProcess.getTextValue("savePath")+"/"+AProcess.getTextValue("savePrefix"))') )

	cmds.separator( style='none' )
	cmds.button( label='Playblast Range (Screenshot)', command=('AProcess.screenshot(AProcess.getTextValue("drawProcess"),AProcess.getTextValue("startNumer"),AProcess.getTextValue("endNumer"),AProcess.getTextValue("savePath")+"/"+AProcess.getTextValue("savePrefix"))') )

	# cmds.separator( style='none' )
	# cmds.button( label='runExec', command=('AProcess.exe(AProcess.getTextValue("drawProcess"))') )
	
	#cmds.button( label='attach', command=('print "python("+getTextValue("drawProcess")+")"') )
	cmds.setParent( '..' )
	cmds.setParent( '..' )
	
	
	cmds.frameLayout( label='Info' ,cll=1, cl=1)
	cmds.rowColumnLayout( numberOfColumns=1)
	cmds.button( label='about()', command=('AProcess.about()') )
	cmds.setParent( '..' )
	cmds.setParent( '..' )
	# cmds.showWindow( window_AP )
	
ui()



'''
#example usage


sys.path.append("c:\mayaModules") #change the path to where you place this file (AProcess.py)
import AProcess
reload(AProcess)

#################################
## simple example function

# def draw(num):
	# testObj = "pCube1"
	# cmds.select(testObj)
	# cmds.move(random.uniform(-num,num),0,random.uniform(-num,num),r=1)
	# cmds.select(cl=1)
	
#################################
## function sequencing

# so it renders where you place the codes within each iteration
# resulting in filename like tmpFile0005step1.jpg
# where 0005 is the main loopcount (edit through Run Count)
# and "step1" is an argument you give scriptRender/scriptShots

# Do not use render range if you insert the render code here
# instead press Toggle renderBln and use Run Once (Exec) or Run N Times (Exec)
	
def draw(num):

	#FIND CURRENT COUNT AProcess.count

	testObj = "pCube1"

	# first step : move
	cmds.select(testObj)
	cmds.move(random.uniform(-num,num),0,random.uniform(-num,num),r=1)
	cmds.select(cl=1)
	# if AProcess.renderBln:AProcess.scriptShots("step1")
	if AProcess.renderBln:AProcess.scriptRender("step1")
	
	#second step : scale
	cmds.setAttr(testObj+".scaleY",random.uniform(0,num))
	# if AProcess.renderBln:AProcess.scriptShots("step2")
	if AProcess.renderBln:AProcess.scriptRender("step2")
	
	#3rd step : rotate
	cmds.setAttr(testObj+".rotateY",random.uniform(0,num*10))
	# if AProcess.renderBln:AProcess.scriptShots("step3")
	if AProcess.renderBln:AProcess.scriptRender("step3")
	
	
	AProcess.incrementCounter()
	
'''